﻿using System;

namespace WindowsFormsApplication1
{
    class Vector
    {
        public float X;
        public float Y;
        public float Z;

        public Vector(float x, float y, float z)
        {
            this.X = x;
            this.Y = y;
            this.Z = z;
        }

        public Vector()
        {
            this.X = 0;
            this.Y = 0;
            this.Z = 0;
        }

        /// <summary>
        /// Berechnung der Position von this
        /// mit der Geschwindigkeit zum Zeitpunkt
        /// </summary>
        /// <param name="speed"></param>
        /// <param name="duration"></param>
        public void ChangePosition(Vector speed, float duration)
        {
            this.X += duration * speed.X;
            this.Y += duration * speed.Y;
            this.Z += duration * speed.Z;
        }

        /// <summary>
        /// unäre Subtraktion
        /// </summary>
        /// <param name="v1"></param>
        /// <param name="v2"></param>
        /// <returns></returns>
        public static Vector operator -(Vector v1, Vector v2)
        {
            return new Vector(v1.X - v2.X, v1.Y - v2.Y, v1.Z - v2.Z);
        }

        /// <summary>
        /// Berechnung der Länge des Vektors
        /// </summary>
        /// <returns>die Länge</returns>
        public float Betrag()
        {
            return (float)(Math.Sqrt(this.X * this.X + this.Y * this.Y + this.Z * this.Z));
        }

        /// <summary>
        /// zur Anzeige im Debugger
        /// </summary>
        public override string ToString()
        {
            return string.Format("{{X={0}, Y={1}, Z={2}}}", this.X, this.Y, this.Z);
        }

        /// <summary>
        /// unäre Addition
        /// </summary>
        /// <param name="v1"></param>
        /// <param name="v2"></param>
        /// <returns></returns>
        public static Vector operator +(Vector v1, Vector v2)
        {
            return new Vector(v1.X + v2.X, v1.Y + v2.Y, v1.Z + v2.Z);
        }

        /// <summary>
        /// Vektor multipliziert mit Skalar
        /// </summary>
        /// <param name="d"></param>
        /// <param name="v"></param>
        /// <returns></returns>
        public static Vector operator *(float d, Vector v)
        {
            return new Vector(d * v.X, d * v.Y, d * v.Z);
        }

        /// <summary>
        /// Vektor dividiert durch Skalar
        /// </summary>
        /// <param name="v"></param>
        /// <param name="d"></param>
        /// <returns></returns>
        public static Vector operator /(Vector v, float d)
        {
            return new Vector(v.X / d, v.Y / d, v.Z / d);
        }
    }
}
